## elastix 4.9.0

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 2.8 )

project( elastix )

#---------------------------------------------------------------------
cmake_policy( SET CMP0012 NEW )
if( POLICY CMP0033 )
  # This policy was introduced in cmake 3, so we need to check for its
  # existence. When the minimum cmake version above is upgraded to 3
  # this if(POLICY) check can be removed.
  cmake_policy( SET CMP0033 OLD )
endif()

cmake_policy( SET CMP0007 OLD )
cmake_policy( SET CMP0042 NEW )

#---------------------------------------------------------------------
# Get version information.

# Get the version number of elastix
file( STRINGS ${elastix_SOURCE_DIR}/Core/Install/elxBaseComponent.h
  ELASTIX_VERSION REGEX "\(#define\ __ELASTIX_VERSION\)" )
string( SUBSTRING ${ELASTIX_VERSION} 26 3 ELASTIX_VERSION )

# Split version in major minor. Assuming no patch number, just x.y
string( REGEX MATCH "[0-9]+" ELASTIX_VERSION_MAJOR "${ELASTIX_VERSION}" )
string( REGEX REPLACE "([0-9]+)\\." "" ELASTIX_VERSION_MINOR "${ELASTIX_VERSION}" )

#---------------------------------------------------------------------
include( CTest )

#---------------------------------------------------------------------
# Generate executable, static library or dynamic library.
mark_as_advanced( ELASTIX_BUILD_EXECUTABLE )
option( ELASTIX_BUILD_EXECUTABLE "Generate executable or library?" ON )

if( NOT ELASTIX_BUILD_EXECUTABLE )
  add_definitions( -D_ELASTIX_BUILD_LIBRARY )

  # The following may make smaller and quicker loading libraries,
  # that hides unnecessary symbols. Available from CMake 3.0.0.
  #set( CMAKE_C_VISIBILITY_PRESET hidden )
  #set( CMAKE_CXX_VISIBILITY_PRESET hidden )

  mark_as_advanced( BUILD_SHARED_LIBS )
  option( BUILD_SHARED_LIBS "Build shared libraries?" OFF )
  if( BUILD_SHARED_LIBS )
    add_definitions( -D_ELASTIX_USE_SHARED_LIBRARY )

    # We need to make sure that also the ITK is compiled with shared
    # libraries on. Related to flag (ITK_)BUILD_SHARED_LIBS. todo

    # In order to compile a shared library, all static sub-libraries
    # need to build position independend code.
    # Otherwise an error similar to the following is raised:
    #   relocation R_X86_64_32S against `.bss' can not be used when
    #   making a shared object; recompile with -fPIC
    set( CMAKE_POSITION_INDEPENDENT_CODE ON )
  endif()
endif()

#---------------------------------------------------------------------
# Find ITK.
find_package( ITK REQUIRED )
include( ${ITK_USE_FILE} )

#---------------------------------------------------------------------
# Add the CMake dir as an additional module path,
# so that CMake is able to find the FindPackage modules.
list( APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake )

# Function for exporting targets
include(elastixExportTarget)

#---------------------------------------------------------------------
# Find OpenCL.
option( ELASTIX_USE_OPENCL "Use OpenCL enabled GPU" OFF )

if( ELASTIX_USE_OPENCL )
  find_package( OpenCL REQUIRED QUIET )

  # Make sure ITK is not compiled with GPU extensions on,
  # since elastix overrides ITK classes with new ones.
  if( ${ITK_USE_GPU} )
    message( FATAL_ERROR "ITK_USE_GPU: " ${ITK_USE_GPU}
      "\nERROR: ITK should be compiled with ITK_USE_GPU OFF, as elastix overrides ITK classes." )
  endif()

  # Force OPENCL_OPTIMIZATION_MAD_ENABLE to on
  if( DEFINED OPENCL_OPTIMIZATION_MAD_ENABLE )
    set( OPENCL_OPTIMIZATION_MAD_ENABLE ON CACHE BOOL
      "Allow a * b + c to be replaced by a mad. The mad computes a * b + c with reduced accuracy." FORCE )
  endif()

  # Include the OpenCL include directories to elastix
  include_directories( ${OPENCL_INCLUDE_DIRS} )

  # Add some useful macro's
  include( elastixOpenCL )

  # Add definition for the OpenCL
  add_definitions( -DELASTIX_USE_OPENCL )
endif()

#---------------------------------------------------------------------
# Find Eigen
mark_as_advanced( ELASTIX_USE_EIGEN )
option( ELASTIX_USE_EIGEN "Use Eigen library." OFF )

if( ELASTIX_USE_EIGEN )
  find_package( Eigen3 REQUIRED )
  include_directories( ${EIGEN3_INCLUDE_DIR} )
  add_definitions( -DELASTIX_USE_EIGEN )
endif()

#---------------------------------------------------------------------
# Find OpenMP
mark_as_advanced( ELASTIX_USE_OPENMP )
option( ELASTIX_USE_OPENMP "Use OpenMP to speed up certain computations." ON )

if( ELASTIX_USE_OPENMP )
  find_package( OpenMP QUIET )
  if( OPENMP_FOUND )
    set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}" )
    #  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}
    #  ${OpenMP_EXE_LINKER_FLAGS}")
    add_definitions( -DELASTIX_USE_OPENMP )
  endif()
endif()

#----------------------------------------------------------------------
# Check for the SuiteSparse package
# We need to do that here, because the link_directories should be set
# before declaring any targets.

if( USE_PreconditionedGradientDescent )
 set( SUITESPARSE_BINARY_DIR "" CACHE PATH "Path to SuiteSparse" )
 set( SUITESPARSE_USE_FILE ${SUITESPARSE_BINARY_DIR}/UseSuiteSparse.cmake )
 if( EXISTS ${SUITESPARSE_USE_FILE} )
  include( ${SUITESPARSE_USE_FILE} )
 endif()
endif()

#---------------------------------------------------------------------
# Set single (build-tree) output directories for all executables and libraries.
# This makes it easier to create an elxUseFile.cmake, that users can
# include in their programs to borrow elastix functionality.

if( NOT LIBRARY_OUTPUT_PATH )
  set( LIBRARY_OUTPUT_PATH ${elastix_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all libraries." )
endif()

if( NOT EXECUTABLE_OUTPUT_PATH )
  set( EXECUTABLE_OUTPUT_PATH ${elastix_BINARY_DIR}/bin CACHE INTERNAL
    "Single output directory for building all executables." )
endif()

# Mark these variables as advanced; their default value is usually fine
mark_as_advanced( LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH )

#---------------------------------------------------------------------
# Define the install directory names, relative to install prefix
# given by CMAKE_INSTALL_PREFIX.  All components should use the
# same name.  Set as variable here for future customization; e.g.
# if desire to decorate with Elastix version.
# Allow user to customize.

mark_as_advanced( ELASTIX_ARCHIVE_DIR ELASTIX_INCLUDE_DIR ELASTIX_LIBRARY_DIR ELASTIX_RUNTIME_DIR )
set( ELASTIX_ARCHIVE_DIR "lib"      CACHE STRING
  "Directory for installing archive files; path is relative to CMAKE_INSTALL_PREFIX" )
set( ELASTIX_INCLUDE_DIR "include"  CACHE STRING
  "Directory for installing include files; path is relative to CMAKE_INSTALL_PREFIX" )
set( ELASTIX_LIBRARY_DIR "lib"      CACHE STRING
  "Directory for installing library files; path is relative to CMAKE_INSTALL_PREFIX" )
set( ELASTIX_RUNTIME_DIR "bin"      CACHE STRING
  "Directory for installing runtime files; path is relative to CMAKE_INSTALL_PREFIX" )

#---------------------------------------------------------------------
# Check if Mevis DicomTiff support is desired
mark_as_advanced( ELASTIX_USE_MEVISDICOMTIFF )
option( ELASTIX_USE_MEVISDICOMTIFF
  "Support MevisLab DicomTiff image format" OFF )

#---------------------------------------------------------------------
# Define cmake variable to define extra user component directories
# These directories will be added to the list of include directories
# and they will be searched for CMakeLists.txt files for further
# processing. In these directories, users may put code for their own
# components.

mark_as_advanced( ELASTIX_USER_COMPONENT_DIRS )
set( ELASTIX_USER_COMPONENT_DIRS "" CACHE PATH
  "directories with user defined elastix components" )

#---------------------------------------------------------------------
# If IDE supports it, do use folder view.
# gcc automatically ignores it. VC Express does not support and gives
# annoying warnings when this option is turned on.
# VC pro does support it.
set( CMAKE_USE_FOLDERS ON CACHE INTERNAL "Use folder view in IDE" )
if( CMAKE_MAKE_PROGRAM MATCHES ".?VCExpress.?" )
  set( CMAKE_USE_FOLDERS OFF CACHE INTERNAL "Use folder view in IDE" )
endif()
set_property( GLOBAL PROPERTY USE_FOLDERS ${CMAKE_USE_FOLDERS} )

#---------------------------------------------------------------------
# Set default build type to Release, if none was specified
# Taken from ITK CMake list
if( NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES )
  message( STATUS "Setting build type to 'Release' as none was specified." )
  set( CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE )
  # Set the possible values of build type for cmake-gui
  set_property( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug" "Release" "MinSizeRel" "RelWithDebInfo" )
endif()

#---------------------------------------------------------------------
# Include directories

set( elxCommon_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Common
  ${elastix_SOURCE_DIR}/Common/CostFunctions
  ${elastix_SOURCE_DIR}/Common/ImageSamplers
  ${elastix_SOURCE_DIR}/Common/LineSearchOptimizers
  ${elastix_SOURCE_DIR}/Common/ParameterFileParser
  ${elastix_SOURCE_DIR}/Common/Transforms
  ${elastix_SOURCE_DIR}/Common/xout
  ${elastix_SOURCE_DIR}/Common/MevisDicomTiff
)

set( elxCommon_OpenCL_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Common/OpenCL
  ${elastix_SOURCE_DIR}/Common/OpenCL/Factories
  ${elastix_SOURCE_DIR}/Common/OpenCL/ITKimprovements
  ${elastix_SOURCE_DIR}/Common/OpenCL/Filters
  ${elastix_SOURCE_DIR}/Common/OpenCL/Kernels
)

set( elxCore_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Core
  ${elastix_SOURCE_DIR}/Core/Install
  ${elastix_SOURCE_DIR}/Core/Kernel
  ${elastix_SOURCE_DIR}/Core/ComponentBaseClasses
  ${elastix_SOURCE_DIR}/Core/Configuration
  ${elastix_SOURCE_DIR}/Core/Main
)

set( elxComponents_INCLUDE_DIRECTORIES
  ${elastix_SOURCE_DIR}/Components/FixedImagePyramids
  ${elastix_SOURCE_DIR}/Components/ImageSamplers
  ${elastix_SOURCE_DIR}/Components/Interpolators
  ${elastix_SOURCE_DIR}/Components/Metrics
  ${elastix_SOURCE_DIR}/Components/MovingImagePyramids
  ${elastix_SOURCE_DIR}/Components/Optimizers
  ${elastix_SOURCE_DIR}/Components/Registrations
  ${elastix_SOURCE_DIR}/Components/ResampleInterpolators
  ${elastix_SOURCE_DIR}/Components/Resamplers
  ${elastix_SOURCE_DIR}/Components/Transforms
)

set( elxINCLUDE_DIRECTORIES
  ${elxCommon_INCLUDE_DIRECTORIES}
  ${elxCore_INCLUDE_DIRECTORIES}
  ${elxComponents_INCLUDE_DIRECTORIES}
  ${elastix_BINARY_DIR}
  ${ELASTIX_USER_COMPONENT_DIRS}
)

include_directories( ${elxINCLUDE_DIRECTORIES} )

# include the OpenCL directories
# The key-word BEFORE is important here, because the elastix distribution
# contains some files with the same name as in the ITK distribution.
# Some bugs were fixed and features added. When these are contributed back
# to the ITK the BEFORE keyword is not needed anymore.
if( ELASTIX_USE_OPENCL )
  include_directories( BEFORE ${elxCommon_OpenCL_INCLUDE_DIRECTORIES} )
endif()

#---------------------------------------------------------------------
# Microsoft specific items

if( MSVC )
  # Kill the anoying MS VS warning about non-safe functions.
  # They hide real warnings.
  add_definitions(
    /D_SCL_SECURE_NO_DEPRECATE
    /D_CRT_SECURE_NO_DEPRECATE
    /D_CRT_TIME_FUNCTIONS_NO_DEPRECATE )

  # Increases address capacity
  if( WIN32 )
    set( CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /bigobj" )
    set( CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /bigobj" )
    set( CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /bigobj" )
  endif()
endif()

#---------------------------------------------------------------------
# Process the sub-directories

# Common dir: code that is neither related to the core of elastix or
# to specific components.
add_subdirectory( Common )

# Components: the registration components such as metrics, transforms,
# optimizers, etc.
add_subdirectory( Components )

=== Common/CMakeLists.txt ===
#---------------------------------------------------------------------
project( elxCommon )

#---------------------------------------------------------------------
# Sub-projects.

add_subdirectory( ParameterFileParser )
add_subdirectory( xout )
add_subdirectory( MevisDicomTiff )

if( ELASTIX_USE_OPENCL )
  add_subdirectory( OpenCL )
endif()

#---------------------------------------------------------------------
# Define lists of files in the subdirectories.

set( CommonFiles
  itkAdvancedLinearInterpolateImageFunction.h
  itkAdvancedLinearInterpolateImageFunction.hxx
  itkAdvancedRayCastInterpolateImageFunction.h
  itkAdvancedRayCastInterpolateImageFunction.hxx
  itkComputeDisplacementDistribution.h
  itkComputeDisplacementDistribution.hxx
  itkComputeJacobianTerms.h
  itkComputeJacobianTerms.hxx
  itkErodeMaskImageFilter.h
  itkErodeMaskImageFilter.hxx
  itkGenericMultiResolutionPyramidImageFilter.h
  itkGenericMultiResolutionPyramidImageFilter.hxx
  itkImageFileCastWriter.h
  itkImageFileCastWriter.hxx
  itkImageMaskSpatialObject2.h
  itkImageMaskSpatialObject2.hxx
  itkImageSpatialObject2.h
  itkImageSpatialObject2.hxx
  itkMeshFileReaderBase.h
  itkMeshFileReaderBase.hxx
  itkMultiOrderBSplineDecompositionImageFilter.h
  itkMultiOrderBSplineDecompositionImageFilter.hxx
  itkMultiResolutionGaussianSmoothingPyramidImageFilter.h
  itkMultiResolutionGaussianSmoothingPyramidImageFilter.hxx
  itkMultiResolutionImageRegistrationMethod2.h
  itkMultiResolutionImageRegistrationMethod2.hxx
  itkMultiResolutionShrinkPyramidImageFilter.h
  itkMultiResolutionShrinkPyramidImageFilter.hxx
  itkNDImageBase.h
  itkNDImageTemplate.h
  itkNDImageTemplate.hxx
  itkParabolicErodeDilateImageFilter.h
  itkParabolicErodeDilateImageFilter.hxx
  itkParabolicErodeImageFilter.h
  itkParabolicMorphUtils.h
  itkRecursiveBSplineInterpolationWeightFunction.h
  itkRecursiveBSplineInterpolationWeightFunction.hxx
  itkReducedDimensionBSplineInterpolateImageFunction.h
  itkReducedDimensionBSplineInterpolateImageFunction.hxx
  itkScaledSingleValuedNonLinearOptimizer.cxx
  itkScaledSingleValuedNonLinearOptimizer.h
  itkTransformixInputPointFileReader.h
  itkTransformixInputPointFileReader.hxx
  TypeList.h
)

set( CostFunctionFiles
  CostFunctions/itkAdvancedImageToImageMetric.h
  CostFunctions/itkAdvancedImageToImageMetric.hxx
  CostFunctions/itkExponentialLimiterFunction.h
  CostFunctions/itkExponentialLimiterFunction.hxx
  CostFunctions/itkHardLimiterFunction.h
  CostFunctions/itkHardLimiterFunction.hxx
  CostFunctions/itkImageToImageMetricWithFeatures.h
  CostFunctions/itkImageToImageMetricWithFeatures.hxx
  CostFunctions/itkLimiterFunctionBase.h
  CostFunctions/itkMultiInputImageToImageMetricBase.h
  CostFunctions/itkMultiInputImageToImageMetricBase.hxx
  CostFunctions/itkParzenWindowHistogramImageToImageMetric.h
  CostFunctions/itkParzenWindowHistogramImageToImageMetric.hxx
  CostFunctions/itkScaledSingleValuedCostFunction.cxx
  CostFunctions/itkScaledSingleValuedCostFunction.h
  CostFunctions/itkSingleValuedPointSetToPointSetMetric.h
  CostFunctions/itkSingleValuedPointSetToPointSetMetric.hxx
  CostFunctions/itkTransformPenaltyTerm.h
  CostFunctions/itkTransformPenaltyTerm.hxx
)

set( TransformFiles
  Transforms/itkAdvancedBSplineDeformableTransformBase.h
  Transforms/itkAdvancedBSplineDeformableTransformBase.hxx
  Transforms/itkAdvancedBSplineDeformableTransform.h
  Transforms/itkAdvancedBSplineDeformableTransform.hxx
  Transforms/itkAdvancedCombinationTransform.h
  Transforms/itkAdvancedCombinationTransform.hxx
  Transforms/itkAdvancedEuler3DTransform.h
  Transforms/itkAdvancedEuler3DTransform.hxx
  Transforms/itkAdvancedIdentityTransform.h
  Transforms/itkAdvancedMatrixOffsetTransformBase.h
  Transforms/itkAdvancedMatrixOffsetTransformBase.hxx
  Transforms/itkAdvancedRigid2DTransform.h
  Transforms/itkAdvancedRigid2DTransform.hxx
  Transforms/itkAdvancedRigid3DTransform.h
  Transforms/itkAdvancedRigid3DTransform.hxx
  Transforms/itkAdvancedSimilarity2DTransform.h
  Transforms/itkAdvancedSimilarity2DTransform.hxx
  Transforms/itkAdvancedSimilarity3DTransform.h
  Transforms/itkAdvancedSimilarity3DTransform.hxx
  Transforms/itkAdvancedTransform.h
  Transforms/itkAdvancedTransform.hxx
  Transforms/itkAdvancedTranslationTransform.h
  Transforms/itkAdvancedTranslationTransform.hxx
  Transforms/itkAdvancedVersorTransform.h
  Transforms/itkAdvancedVersorTransform.hxx
  Transforms/itkAdvancedVersorRigid3DTransform.h
  Transforms/itkAdvancedVersorRigid3DTransform.hxx
  Transforms/itkBSplineDerivativeKernelFunction2.h
  Transforms/itkBSplineInterpolationDerivativeWeightFunction.h
  Transforms/itkBSplineInterpolationDerivativeWeightFunction.hxx
  Transforms/itkBSplineInterpolationSecondOrderDerivativeWeightFunction.h
  Transforms/itkBSplineInterpolationSecondOrderDerivativeWeightFunction.hxx
  Transforms/itkBSplineInterpolationWeightFunction2.h
  Transforms/itkBSplineInterpolationWeightFunction2.hxx
  Transforms/itkBSplineInterpolationWeightFunctionBase.h
  Transforms/itkBSplineInterpolationWeightFunctionBase.hxx
  Transforms/itkBSplineKernelFunction2.h
  Transforms/itkBSplineSecondOrderDerivativeKernelFunction2.h
  Transforms/itkCyclicBSplineDeformableTransform.h
  Transforms/itkCyclicBSplineDeformableTransform.hxx
  Transforms/itkCyclicGridScheduleComputer.h
  Transforms/itkCyclicGridScheduleComputer.hxx
  Transforms/itkEulerTransform.h
  Transforms/itkGridScheduleComputer.h
  Transforms/itkGridScheduleComputer.hxx
  Transforms/itkRecursiveBSplineTransform.hxx
  Transforms/itkRecursiveBSplineTransform.h
  Transforms/itkRecursiveBSplineTransformImplementation.h
  Transforms/itkStackTransform.h
  Transforms/itkStackTransform.hxx
  Transforms/itkTransformToDeterminantOfSpatialJacobianSource.h
  Transforms/itkTransformToDeterminantOfSpatialJacobianSource.hxx
  Transforms/itkTransformToSpatialJacobianSource.h
  Transforms/itkTransformToSpatialJacobianSource.hxx
  Transforms/itkUpsampleBSplineParametersFilter.h
  Transforms/itkUpsampleBSplineParametersFilter.hxx
)

set( LineSearchOptimizersFiles
  LineSearchOptimizers/itkMoreThuenteLineSearchOptimizer.h
  LineSearchOptimizers/itkMoreThuenteLineSearchOptimizer.cxx
  LineSearchOptimizers/itkLineSearchOptimizer.h
  LineSearchOptimizers/itkLineSearchOptimizer.cxx
)

set( ImageSamplersFiles
  ImageSamplers/itkImageFullSampler.h
  ImageSamplers/itkImageFullSampler.hxx
  ImageSamplers/itkImageGridSampler.h
  ImageSamplers/itkImageGridSampler.hxx
  ImageSamplers/itkImageRandomCoordinateSampler.h
  ImageSamplers/itkImageRandomCoordinateSampler.hxx
  ImageSamplers/itkImageRandomSampler.h
  ImageSamplers/itkImageRandomSampler.hxx
  ImageSamplers/itkImageRandomSamplerBase.h
  ImageSamplers/itkImageRandomSamplerSparseMask.h
  ImageSamplers/itkImageRandomSamplerSparseMask.hxx
  ImageSamplers/itkImageSample.h
  ImageSamplers/itkImageSamplerBase.h
  ImageSamplers/itkImageSamplerBase.hxx
  ImageSamplers/itkImageToVectorContainerFilter.h
  ImageSamplers/itkImageToVectorContainerFilter.hxx
  ImageSamplers/itkMultiInputImageRandomCoordinateSampler.h
  ImageSamplers/itkMultiInputImageRandomCoordinateSampler.hxx
  ImageSamplers/itkVectorContainerSource.h
  ImageSamplers/itkVectorContainerSource.hxx
  ImageSamplers/itkVectorDataContainer.h
  ImageSamplers/itkVectorDataContainer.hxx
)

#---------------------------------------------------------------------
# Construct source groups for nice visualisation in Visual Studio.

source_group( "Common" FILES ${CommonFiles} )
source_group( "CostFunctions" FILES ${CostFunctionFiles} )
source_group( "Transforms" FILES ${TransformFiles} )
source_group( "LineSearchOptimizers" FILES ${LineSearchOptimizersFiles} )
source_group( "ImageSamplers" FILES ${ImageSamplersFiles} )

#---------------------------------------------------------------------
# Create the elxCommon library.

add_library( elxCommon STATIC
  ${CommonFiles}
  ${CostFunctionFiles}
  ${TransformFiles}
  ${LineSearchOptimizersFiles}
  ${ImageSamplersFiles}
)
install( TARGETS elxCommon
  ARCHIVE DESTINATION ${ELASTIX_ARCHIVE_DIR}
  LIBRARY DESTINATION ${ELASTIX_LIBRARY_DIR}
  RUNTIME DESTINATION ${ELASTIX_RUNTIME_DIR} )

#---------------------------------------------------------------------
# Link against other libraries.

if( UNIX AND NOT APPLE )
  target_link_libraries( elxCommon
    ${ITK_LIBRARIES}
    rt # Needed for elxTimer, clock_gettime()
  )
else()
  target_link_libraries( elxCommon
    ${ITK_LIBRARIES}
  )
endif()

=== Core/CMakeLists.txt ===
#---------------------------------------------------------------------
project( elxCore )

#---------------------------------------------------------------------
# Define lists of files in the subdirectories.

set( KernelFilesForExecutables
  Kernel/elxElastixMain.cxx
  Kernel/elxElastixMain.h
  Kernel/elxTransformixMain.cxx
  Kernel/elxTransformixMain.h
)

set( KernelFilesForComponents
  Kernel/elxElastixBase.cxx
  Kernel/elxElastixBase.h
  Kernel/elxElastixTemplate.h
  Kernel/elxElastixTemplate.hxx
)

set( InstallFilesForExecutables
  Install/elxComponentLoader.cxx
  Install/elxComponentLoader.h
)

set( InstallFilesForComponents
  Install/elxComponentDatabase.cxx
  Install/elxComponentDatabase.h
  Install/elxBaseComponent.cxx
  Install/elxBaseComponent.h
  Install/elxBaseComponentSE.h
  Install/elxBaseComponentSE.hxx
  Install/elxInstallAllComponents.h
  Install/elxInstallFunctions.h
  Install/elxMacro.h
  Install/elxIncludes.h
)

set( ConfigurationFiles
  Configuration/elxConfiguration.cxx
  Configuration/elxConfiguration.h
)

set( ComponentBaseClassFiles
  ComponentBaseClasses/elxFixedImagePyramidBase.h
  ComponentBaseClasses/elxImageSamplerBase.h
  ComponentBaseClasses/elxInterpolatorBase.h
  ComponentBaseClasses/elxMetricBase.h
  ComponentBaseClasses/elxMovingImagePyramidBase.h
  ComponentBaseClasses/elxOptimizerBase.h
  ComponentBaseClasses/elxRegistrationBase.h
  ComponentBaseClasses/elxResampleInterpolatorBase.h
  ComponentBaseClasses/elxResamplerBase.h
  ComponentBaseClasses/elxTransformBase.h
  ComponentBaseClasses/elxFixedImagePyramidBase.hxx
  ComponentBaseClasses/elxImageSamplerBase.hxx
  ComponentBaseClasses/elxInterpolatorBase.hxx
  ComponentBaseClasses/elxMetricBase.hxx
  ComponentBaseClasses/elxMovingImagePyramidBase.hxx
  ComponentBaseClasses/elxOptimizerBase.hxx
  ComponentBaseClasses/elxRegistrationBase.hxx
  ComponentBaseClasses/elxResampleInterpolatorBase.hxx
  ComponentBaseClasses/elxResamplerBase.hxx
  ComponentBaseClasses/elxTransformBase.hxx
)

set( ProgressCommandFiles
  elxProgressCommand.cxx
  elxProgressCommand.h
)

#---------------------------------------------------------------------
# Construct source groups for nice visualisation in Visual Studio.

source_group( "Install" FILES
  ${InstallFilesForComponents}
  ${InstallFilesForExecutables}
)

source_group( "Kernel" FILES
  ${KernelFilesForComponents}
  ${KernelFilesForExecutables}
)

source_group( "Configuration" FILES ${ConfigurationFiles} )
source_group( "ComponentBaseClasses" FILES ${ComponentBaseClassFiles} )
source_group( "ProgressCommand" FILES ${ProgressCommandFiles} )

#---------------------------------------------------------------------
# Create the elxCore library.

add_library( elxCore STATIC
  ${KernelFilesForComponents}
  ${InstallFilesForComponents}
  ${ConfigurationFiles}
  ${ComponentBaseClassFiles}
  ${ProgressCommandFiles}
)

elastix_export_target( elxCore )

#---------------------------------------------------------------------
# Link against other libraries.

target_link_libraries( elxCore
  elxCommon
  xoutlib
  param # Needed for elxConfiguration
  #  ${ITK_LIBRARIES}
)

elastix_export_target( elxCommon )
elastix_export_target( xoutlib )
elastix_export_target( param )

#---------------------------------------------------------------------
# Define the mevis dcm tiff lib to which we should link.
set( mevisdcmtifflib mevisdcmtiff )

#---------------------------------------------------------------------
# Create the elastix executable or library.
if( ELASTIX_BUILD_EXECUTABLE )
  add_executable( elastix
    Main/elastix.cxx
    Main/elastix.h
    Kernel/elxElastixMain.cxx
    Kernel/elxElastixMain.h
    ${InstallFilesForExecutables}
  )
else()
  # The library type (STATIC or SHARED) is determined by the parameter
  # BUILD_SHARED_LIBS.
  add_library( elastix
    Main/elxParameterObject.cxx
    Main/elxParameterObject.h
    Main/elastixlib.cxx
    Main/elastixlib.h
    Kernel/elxElastixMain.cxx
    Kernel/elxElastixMain.h
    ${InstallFilesForExecutables}
  )
endif()

#---------------------------------------------------------------------
# Create the transformix executable.

if( ELASTIX_BUILD_EXECUTABLE )
  add_executable( transformix
    Main/transformix.cxx
    Main/elastix.h
    Kernel/elxElastixMain.cxx
    Kernel/elxElastixMain.h
    Kernel/elxTransformixMain.cxx
    Kernel/elxTransformixMain.h
    ${InstallFilesForExecutables}
  )
else()
  # The library type (STATIC or SHARED) is determined by the parameter
  # BUILD_SHARED_LIBS.
  add_library( transformix
    Main/elxParameterObject.cxx
    Main/elxParameterObject.h
    Main/transformixlib.cxx
    Main/transformixlib.h
    Kernel/elxElastixMain.cxx
    Kernel/elxElastixMain.h
    Kernel/elxTransformixMain.cxx
    Kernel/elxTransformixMain.h
    ${InstallFilesForExecutables}
  )
  set( ELASTIX_LIBRARIES elastix transformix PARENT_SCOPE )
endif()

#---------------------------------------------------------------------
# Link elastix against other libraries.

target_link_libraries( elastix
  param
  xoutlib
  elxCommon
  elxCore
  ${mevisdcmtifflib}
  ${AllComponentLibs}
  ${ITK_LIBRARIES}
)

if( ELASTIX_USE_OPENCL )
  target_link_libraries( elastix elxOpenCL )
endif()

#---------------------------------------------------------------------
# Link transformix against other libraries.

target_link_libraries( transformix
  param
  xoutlib
  elxCommon
  elxCore
  ${mevisdcmtifflib}
  ${AllComponentLibs}
  ${ITK_LIBRARIES}
)

if( ELASTIX_USE_OPENCL )
  target_link_libraries( transformix elxOpenCL )
endif()

if( MSVC )
  # NOTE: that linker /INCREMENTAL:NO flag makes it impossible to use
  # Debug breakpoints in Visual Studio 10.0. It is probably the Visual Studio 10.0 bug.
  # Or you have to recompile ITK with the same flag in Debug as well.
  # Or it has something to do with building it with IncrediBuild where this flag is not welcome for PDB files.
  # Therefore we are going to set it only for Visual Studio 9.0 (2008)
  if( MSVC90 OR MSVC91 )
    set( CMAKE_EXE_LINKER_FLAGS_DEBUG "/INCREMENTAL:NO" )
  endif()
endif()

#---------------------------------------------------------------------
# Define the install directory for elastix and transformix.

if( NOT WIN32 )
  # Tell the executables where to find the required .so files.
  set_target_properties( elastix transformix
    PROPERTIES INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib:${ITK_DIR}" )
endif()

install( TARGETS elastix transformix elxCore
  ARCHIVE DESTINATION ${ELASTIX_ARCHIVE_DIR}
  LIBRARY DESTINATION ${ELASTIX_LIBRARY_DIR}
  RUNTIME DESTINATION ${ELASTIX_RUNTIME_DIR}
  COMPONENT RuntimeLibraries )

# Install all header files.
install( DIRECTORY
  ${elastix_SOURCE_DIR}/Common
  ${elastix_SOURCE_DIR}/Core
  ${elastix_SOURCE_DIR}/Components
  DESTINATION ${ELASTIX_INCLUDE_DIR}
  FILES_MATCHING PATTERN "*.h" PATTERN "*.hxx" )
install( FILES
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionCalls.h
  ${elastix_BINARY_DIR}/elxInstallComponentFunctionDeclarations.h
  ${elastix_BINARY_DIR}/elxSupportedImageTypes.h
  ${elastix_BINARY_DIR}/ITKFactoryRegistration/itkImageIOFactoryRegisterManager.h
  ${elastix_BINARY_DIR}/ITKFactoryRegistration/itkTransformIOFactoryRegisterManager.h
  DESTINATION ${ELASTIX_INCLUDE_DIR} )

#---------------------------------------------------------------------
# The Core/Install directory contains a CMakeLists file for
# defining the elastix compilation types.

add_subdirectory( Install )

=== Testing/CMakeLists.txt ===
#---------------------------------------------------------------------
project( elxTesting )

# Set some directories
set( TestDataDir ${elastix_SOURCE_DIR}/Testing/Data )
set( TestBaselineDir ${elastix_SOURCE_DIR}/Testing/Baselines )
set( TestOutputDir ${elastix_BINARY_DIR}/Testing )

set( SITE_BASELINE_DIR "" CACHE PATH "path to site-specific baseline data" )
if( SITE_BASELINE_DIR )
  if( EXISTS ${SITE_BASELINE_DIR} )
    set( TestSiteBaselineDir ${SITE_BASELINE_DIR} )
    message( STATUS "Site-specific baseline directory: " ${TestSiteBaselineDir} )
  else()
    message( FATAL_ERROR "Invalid site-specific baseline directory specified: " ${TestSiteBaselineDir} )
  endif()
endif()

#---------------------------------------------------------------------
# configure the baseline files
set( ELASTIX_DATA_DIR ${TestDataDir} )
file( GLOB files ${TestBaselineDir}/*.in )
if( TestSiteBaselineDir )
  file( GLOB sitefiles ${TestSiteBaselineDir}/*.in )
endif()
foreach( tpfile ${files} ${sitefiles} )
  # Get file name without directory
  get_filename_component( tpfileout ${tpfile} NAME )
  # Strip extension .in
  string( REGEX REPLACE "\\.[^.]*$" "" tpfileout ${tpfileout})
  # Replace the initial transform directory with the correct one
  # The resulting file can be found in the binary directory / Testing
  configure_file( ${tpfile} ${elastix_BINARY_DIR}/Testing/${tpfileout} @ONLY )
endforeach()

#---------------------------------------------------------------------
# Python is used by some tests
find_program( python_executable python
  HINTS "C:/Program Files/Python2.7" "C:/Program Files/python3.3" "C:/Program Files/Python35" )
if( NOT python_executable )
  message( WARNING "WARNING: python not found! Some test results can not be evaluated." )
endif()

#---------------------------------------------------------------------
# Add macro to decide if mevisdicomtiff should be tested
if( ELASTIX_USE_MEVISDICOMTIFF )
  add_definitions( -D_ELASTIX_USE_MEVISDICOMTIFF )
endif()
set( mevisdcmtifflib mevisdcmtiff )

#---------------------------------------------------------------------
# Optionally run timing tests
# - tests that are wholly devoted to timing can be added conditionally using cmake symbol ELASTIX_TEST_TIMING
# - tests that have mixed correctness and timing testing can use the C Preprocessor symbol _ELASTIX_TEST_TIMING to
#   conditionally enable the timing testing parts
mark_as_advanced( ELASTIX_TEST_TIMING )
option( ELASTIX_TEST_TIMING "Enable timing tests?  This option enables timing tests among the regular test suite." OFF )
if( ELASTIX_TEST_TIMING )
  add_definitions( -D_ELASTIX_TEST_TIMING )
endif()

#---------------------------------------------------------------------
# Core macro for elx_add_opencl_test() and elx_add_test()
macro( elx_add_test_core executable_name source_name test_name group )
  if( NOT TARGET ${executable_name} )

    # Create the test executable.
    add_executable( ${executable_name} ${source_name}
      itkCommandLineArgumentParser.cxx # some test use the CommandLineArgumentParser
    )

    # Link against other libraries.
    target_link_libraries( ${executable_name}
      param               # some test use the CommandLineArgumentParser
      ${mevisdcmtifflib}  # is empty if not selected in CMake
      ${ITK_LIBRARIES}
    )

    if( ELASTIX_USE_OPENCL )
      include_directories( ${CMAKE_CURRENT_SOURCE_DIR} )
      target_link_libraries( ${executable_name} elxOpenCL )
    endif()

    # Group in IDE's like Visual Studio
    set_property( TARGET ${executable_name} PROPERTY FOLDER "tests/${group}" )
  endif()

  # Add the test.
  add_test( NAME ${test_name}
    COMMAND ${EXECUTABLE_OUTPUT_PATH}/${executable_name} ${ARGN} )

  # GPU test should be run in serial, to avoid memory issues.
  string( COMPARE EQUAL ${group} "OpenCL" isEqual )
  if( ${isEqual} )
    set_tests_properties( ${test_name} PROPERTIES RUN_SERIAL true )
  endif()
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of elastix OpenCL tests
#
# Usage:
# elx_add_opencl_test( <name_of_test> )
#
# We assume here that the name of the source which includes the main is:
#   "itk"name_of_test".cxx".
#

macro( elx_add_opencl_test name number group kernels )
  # Define some helper variables.
  set( ELXTEST_EXECUTABLE_NAME itk${name} )
  set( ELXTEST_SOURCE_NAME itk${name}.cxx itkTestHelper.h itkTestOutputWindow.cxx itkTestOutputWindow.h )
  set( ELXTEST_TEST_NAME ${name}${number} )

  # Count number of kernels provided
  set( all_kernels ${kernels} )
  list( LENGTH all_kernels ELXTEST_OPENCL_NUM_KERNELS )
  if( ${ELXTEST_OPENCL_NUM_KERNELS} GREATER 0 )

    # Kernels source variables
    set( ELXTEST_OPEN_CL_KERNELS )
    set( ELXTEST_OPEN_CL_KERNELS_SRC )

    # If single kernel
    if( ${ELXTEST_OPENCL_NUM_KERNELS} EQUAL 1 )
      # Define OpenCL kernels
      file( GLOB open_cl_kernel_path ${kernels} )
      list( APPEND ELXTEST_OPEN_CL_KERNELS ${open_cl_kernel_path} )

      source_group( "Kernels" FILES ${ELXTEST_OPEN_CL_KERNELS} )
      write_opencl_kernels( "${ELXTEST_OPEN_CL_KERNELS}" ELXTEST_OPEN_CL_KERNELS_SRC "OpenCLTest generated kernels" OFF ${name} )
    # Else if multiple kernels kernel
    elseif( ${ELXTEST_OPENCL_NUM_KERNELS} GREATER 1 )
      # Define OpenCL kernels
      foreach( elem ${kernels} )
        file( GLOB open_cl_kernel_path ${elem} )
        list( APPEND ELXTEST_OPEN_CL_KERNELS ${open_cl_kernel_path} )
      endforeach()

      source_group( "Kernels" FILES ${ELXTEST_OPEN_CL_KERNELS} )
      write_opencl_kernels( "${ELXTEST_OPEN_CL_KERNELS}" ELXTEST_OPEN_CL_KERNELS_SRC "OpenCLTest generated kernels" ON ${name} )
    endif()

    # Append to ELXTEST_SOURCE_NAME
    list( APPEND ELXTEST_SOURCE_NAME ${ELXTEST_OPEN_CL_KERNELS} ${ELXTEST_OPEN_CL_KERNELS_SRC} itk${name}.h )
  endif()

  # Call core macro
  elx_add_test_core( ${ELXTEST_EXECUTABLE_NAME} "${ELXTEST_SOURCE_NAME}" ${ELXTEST_TEST_NAME} ${group} ${ARGN} )
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of elastix tests
#
# Usage:
# elx_add_test( <name_of_test> )
#
# We assume here that the name of the source which includes the main is:
#   "itk"name_of_test".cxx".
#

macro( elx_add_test name number group )
  # Define some helper variables.
  set( ELXTEST_EXECUTABLE_NAME itk${name} )
  set( ELXTEST_SOURCE_NAME itk${name}.cxx )
  set( ELXTEST_TEST_NAME ${name}${number} )

  # Call core macro
  elx_add_test_core( ${ELXTEST_EXECUTABLE_NAME} "${ELXTEST_SOURCE_NAME}" ${ELXTEST_TEST_NAME} ${group} ${ARGN} )
endmacro()

#---------------------------------------------------------------------
# Macro that simplifies the addition of transformix tests
#
# Usage:
# trx_add_test( <name_of_test> <transformix_commandline_arguments> )
#
# The macro runs transformix with the provided commandline arguments.
#

macro( trx_add_test name )
  # Create output directory
  set( testname transformix_run_${name} )
  set( output_dir ${TestOutputDir}/${testname} )
  file( MAKE_DIRECTORY ${output_dir} )

  # Define some helper variables.
  set( TRXTEST_EXECUTABLE_NAME transformix )
  set( TRXTEST_TEST_NAME ${name} )

  # Group in IDE's like Visual Studio
  set_property( TARGET ${ELXTEST_EXECUTABLE_NAME} PROPERTY FOLDER "tests" )

  # Add the test.
  add_test( NAME ${name} COMMAND ${EXECUTABLE_OUTPUT_PATH}/transformix ${ARGN} -out ${output_dir} )
  set_tests_properties( ${name} PROPERTIES TIMEOUT 10000 )
endmacro()

#---------------------------------------------------------------------
# Macro's that simplifies the addition of tests that run elastix
#
# Usage:
# elx_add_run_test( <name_of_test>
#                   IMAGE <name_of_baseline> | METRICVALUE "string"
#                     | CHECKSUM "string"
#                   <elastix_commandline_arguments> )
#

# Get the baseline checksum values file
#
# Ideally, a registration returns exactly the same result, regardless of
# platform, OS and compiler. We observed however, that this is not the case.
# Therefore, for some tests we accept differences between systems, and only
# test for consistency over time for the same system.
#
# To this end we have defined baseline checksum values for several systems.
# The code below checks what the current system is and finds the corresponding
# baseline file. We currently do this by means of the CTEST_SITE and CTEST_BUILD_NAME.
# Different sites can give different results, so we only test the checksum for
# the sites that are known to us, and those are the sites that submit to the
# nightly dashboard. Note that this means that these checksum comparison test
# only work if run via the dashboard scripts.
#
set( knownChecksumSystem false )
set( specializedTransformParameterSystem false )
if( SITE STREQUAL "LKEB.PCMarius"
    AND BUILDNAME STREQUAL "Win10-64bit-VS2015" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.PCMarius_Win10-64bit-VS2015.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "LKEB-ELDB91"
    AND BUILDNAME STREQUAL "Linux-64bit-gcc5.4.0-Release" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.ELDB91_Linux-64bit-gcc5.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "LKEB.MacMini"
    AND BUILDNAME STREQUAL "MacOSX-64bit-gcc4.2.1" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_LKEB.MacMini_MacOSX-64bit-gcc4.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "BIGR.PCStefan"
    AND BUILDNAME STREQUAL "WinXP-32bit-VS2008" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_BIGR.PCStefan_WinXP-32bit-VS2008.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
elseif( SITE STREQUAL "BIGR.cluster"
    AND BUILDNAME STREQUAL "Linux-64bit-gcc4.4.6" )
  set( checksumBaselineFile ${TestBaselineDir}/checksums_BIGR.cluster_Linux-64bit-gcc4.txt )
  set( knownChecksumSystem true )
  set( specializedTransformParameterSystem true )
endif()

if( EXISTS ${TestSiteBaselineDir}/checksums.txt )
  set( checksumBaselineFile ${TestSiteBaselineDir}/checksums.txt )
  set( knownChecksumSystem true )
endif()

if( knownChecksumSystem )
  message( STATUS "Checksum baseline file: " ${checksumBaselineFile} )
endif()

# Python script used for comparing elastix output with baseline results
set( pythonfinalmetric ${elastix_SOURCE_DIR}/Testing/elx_compare_finalmetricvalue.py )
set( pythonchecksum   ${elastix_SOURCE_DIR}/Testing/elx_compare_checksum.py )
set( pythonoverlap    ${elastix_SOURCE_DIR}/Testing/elx_compare_overlap.py )
set( pythonlandmarks  ${elastix_SOURCE_DIR}/Testing/elx_compare_landmarks.py )

# Helper macro
macro( list_count listvar value count )
  set( tmplist )
  foreach( tmpvalue ${listvar} )
    if( ${tmpvalue} STREQUAL ${value} )
      list( APPEND tmplist . )
    endif()
  endforeach()
  list( LENGTH tmplist tmpcount )
  set( ${count} ${tmpcount} )
endmacro()

# Main elastix_run add_test macro
macro( elx_add_run_test testbasename howtocompare )
  # Create output directory
  set( testname elastix_run_${testbasename} )
  set( output_dir ${TestOutputDir}/${testname} )
  file( MAKE_DIRECTORY ${output_dir} )

  # ${ARGN} may be the elastix command line arguments, but also
  # an optional baseline value followed by those arguments.
  set( baseline ${ARGV2} )
  set( elastixargs ${ARGN} )
  string( SUBSTRING ${baseline} 0 1 firstelement )
  string( COMPARE EQUAL ${firstelement} "-" firstelementisdash )
  if( NOT ${firstelementisdash} )
    list( REMOVE_AT elastixargs 0 )
  endif()

  # Number of -p's to deduce result.?.mhd
  list_count( "${ARGN}" "-p" countp )
  math( EXPR countp "${countp} - 1" )

  # Run elastix, but only in release mode
  # Set maximum test length to 10 minutes
  add_test( NAME ${testname}_OUTPUT
    CONFIGURATIONS Release

=== Common/MevisDicomTiff/CMakeLists.txt ===
# include this file in your CMakeLists.txt file using the add_subdirectory command.
project( MevisDicomTiff )

if( ELASTIX_USE_MEVISDICOMTIFF )
  add_definitions( -D_ELASTIX_USE_MEVISDICOMTIFF )
  add_library( mevisdcmtiff STATIC
    itkMevisDicomTiffImageIO.cxx
    itkMevisDicomTiffImageIOFactory.cxx
    itkUseMevisDicomTiff.cxx
  )
else()
  # avoid dependencies, but compile the lib, so that customers of this
  # lib can just call RegisterMevisDicomTiff without checking.
  add_library( mevisdcmtiff STATIC
    itkUseMevisDicomTiff.cxx
  )
endif()

install( TARGETS mevisdcmtiff
  ARCHIVE DESTINATION ${ELASTIX_ARCHIVE_DIR}
  LIBRARY DESTINATION ${ELASTIX_LIBRARY_DIR}
  RUNTIME DESTINATION ${ELASTIX_RUNTIME_DIR} )

target_link_libraries( mevisdcmtiff ${ITK_LIBRARIES} )

# Group in IDE's like Visual Studio
set_property( TARGET mevisdcmtiff PROPERTY FOLDER "libraries" )

# add mevisdcmtiff to the list of target_link_libraries in your cmakelists.txt file.

elastix_export_target( mevisdcmtiff )

=== Common/xout/CMakeLists.txt ===

# This project is intended to be built outside the Insight source tree
project( xout )

set( xoutcfiles xoutmain.cxx xouttest.cxx )

set( xouthxxfiles
  xoutbase.hxx
  xoutsimple.hxx
  xoutrow.hxx
  xoutcell.hxx )

set( xouthfiles
  xoutbase.h
  xoutmain.h
  xoutsimple.h
  xoutrow.h
  xoutcell.h )

# a lib defining the global variable xout.
add_library( xoutlib STATIC xoutmain.cxx ${xouthxxfiles} ${xouthfiles} )
install( TARGETS xoutlib
  ARCHIVE DESTINATION ${ELASTIX_ARCHIVE_DIR}
  LIBRARY DESTINATION ${ELASTIX_LIBRARY_DIR}
  RUNTIME DESTINATION ${ELASTIX_RUNTIME_DIR} )

# Group in IDE's like Visual Studio
set_property( TARGET xoutlib PROPERTY FOLDER "libraries" )

=== Core/Install/CMakeLists.txt ===
#
# This CMakeLists file will generate the file elxSupportedImageTypes.h
# in the bin directory. This file defines the types of images for which
# elastix is compiled.
#

# User specified variables:
mark_as_advanced( ELASTIX_IMAGE_DIMENSIONS )
set( ELASTIX_IMAGE_DIMENSIONS 2 3 4 CACHE STRING "Specify image dimensions" )

mark_as_advanced( ELASTIX_IMAGE_2D_PIXELTYPES )
set( ELASTIX_IMAGE_2D_PIXELTYPES "float" CACHE STRING "Specify 2D pixel types" )

mark_as_advanced( ELASTIX_IMAGE_3D_PIXELTYPES )
set( ELASTIX_IMAGE_3D_PIXELTYPES "short" "float" CACHE STRING "Specify 3D pixel types" )

mark_as_advanced( ELASTIX_IMAGE_4D_PIXELTYPES )
set( ELASTIX_IMAGE_4D_PIXELTYPES "short" CACHE STRING "Specify 4D pixel types" )

# Define supported dimensions and types for sanity checks.
# Gives protection against typo's.
set( supportedDimensions 2 3 4 )
set( supportedTypes "char" "unsigned char"
  "short" "unsigned short" "int" "unsigned int"
  "long" "unsigned long" "float" "double" )

# Sanity check if > 0 number of dimensions are requested
list( LENGTH ELASTIX_IMAGE_DIMENSIONS numDims )
if( ${numDims} EQUAL 0 )
  message( FATAL_ERROR "ERROR: you should set one or more values "
    " to ELASTIX_IMAGE_DIMENSIONS!\n"
    "Choose a subset of {${supportedDimensions}}." )
endif()

# Start a string containing the supported image types
# and initialize some variables.
set( supportString "" )
set( supportOpenCLImages "" )
set( index 1 )
set( numSupported 0 )

# Add supported image types to the string
foreach( dim ${ELASTIX_IMAGE_DIMENSIONS} )

  # Check dimension
  if( ${dim} EQUAL 2 )
    set( pixelTypeList ${ELASTIX_IMAGE_2D_PIXELTYPES} )
    set( whichList "ELASTIX_IMAGE_2D_PIXELTYPES" )
  elseif( ${dim} EQUAL 3 )
    set( pixelTypeList ${ELASTIX_IMAGE_3D_PIXELTYPES} )
    set( whichList "ELASTIX_IMAGE_3D_PIXELTYPES" )
  elseif( ${dim} EQUAL 4 )
    set( pixelTypeList ${ELASTIX_IMAGE_4D_PIXELTYPES} )
    set( whichList "ELASTIX_IMAGE_4D_PIXELTYPES" )
  else()
    message( FATAL_ERROR "ERROR: you selected ELASTIX_IMAGE_DIMENSIONS"
      " to include ${dim}, which is not supported!\n"
      "Choose a subset of {${supportedDimensions}}." )
  endif()

  # Sanity check if > 0 number of pixel types are requested
  list( LENGTH pixelTypeList pixelTypeListLength )
  if( ${pixelTypeListLength} EQUAL 0 )
    message( FATAL_ERROR "ERROR: you should set one or more values"
      " to ${whichList}!\n"
      "Choose a subset of {${supportedTypes}}." )
  endif()

  # Add types
  foreach( type ${pixelTypeList} )
    # Sanity check
    list( FIND supportedTypes ${type} foundIndex )
    if( ${foundIndex} EQUAL -1 )
      message( FATAL_ERROR "ERROR: you selected ${whichList}"
        " to include ${type}, which is not supported!\n"
        "Choose a subset of {${supportedTypes}}." )
    endif()

    # Add type to supportString
    set( supportString
      "${supportString}  elxSupportedImageTypeMacro( ${type}, ${dim}, ${type}, ${dim}, ${index} );\n" )

    # Increase some variables
    math( EXPR index "${index} + 1" )
    math( EXPR numSupported "${numSupported} + 1" )
  endforeach()

  # OpenCL
  if( ELASTIX_USE_OPENCL )
    # Construct supportOpenCLImages
    set( openclindex 0 )
    list( LENGTH pixelTypeList pixelTypeListLength )

    if( supportOpenCLImages STREQUAL "" )
      set( supportOpenCLImages "typedef typelist::MakeTypeList<" )
    else()
      set( supportOpenCLImages "${supportOpenCLImages}\n  typedef typelist::MakeTypeList<" )
    endif()

    foreach( type ${pixelTypeList} )
      set( supportOpenCLImages "${supportOpenCLImages}${type}" )
      math( EXPR openclindex "${openclindex} + 1" )
      if( NOT openclindex EQUAL pixelTypeListLength )
        set( supportOpenCLImages "${supportOpenCLImages}, " )
      endif()
    endforeach()
    set( supportOpenCLImages "${supportOpenCLImages}>::Type OpenCLImageTypes${dim}D;" )
  endif()

endforeach()

# Prepend the string with the number of supported images.
set( supportString
  "const unsigned int NrOfSupportedImageTypes = ${numSupported};\n\n${supportString}" )

# Put the generated string in the elxSupportedImageTypes.h
# header using configure_file.
set( UserDefinedSupportedImageTypes ${supportString} )
configure_file(
  ${elastix_SOURCE_DIR}/Core/Install/elxSupportedImageTypes.h.in
  ${elastix_BINARY_DIR}/elxSupportedImageTypes.h
  @ONLY )

# OpenCL
if( ELASTIX_USE_OPENCL )
  # Construct supportOpenCLDimensions
  set( supportOpenCLDimensions "" )

  # Check 2D
  list( FIND ELASTIX_IMAGE_DIMENSIONS 2 ELASTIX_SUPPORT_OPENCL_2D )
  if( NOT ELASTIX_SUPPORT_OPENCL_2D EQUAL -1 )
    set( tof "true" )
  else()
    set( tof "false" )
  endif()
  set( supportOpenCLDimensions "itkStaticConstMacro( Support2D, bool, ${tof} );" )

  # Check 3D
  list( FIND ELASTIX_IMAGE_DIMENSIONS 3 ELASTIX_SUPPORT_OPENCL_3D )
  if( NOT ELASTIX_SUPPORT_OPENCL_3D EQUAL -1 )
    set( tof "true" )
  else()
    set( tof "false" )
  endif()
  set( supportOpenCLDimensions
    "${supportOpenCLDimensions}\n    itkStaticConstMacro( Support3D, bool, ${tof} );" )

  set( UserDefinedSupportedDimensions "${supportOpenCLDimensions}" )
  set( UserDefinedSupportedImageTypes "${supportOpenCLImages}" )

  # Put the generated string in the elxOpenCLSupportedImageTypes.h
  # header using configure_file.
  configure_file(
    ${elastix_SOURCE_DIR}/Core/Install/elxOpenCLSupportedImageTypes.h.in
    ${elastix_BINARY_DIR}/elxOpenCLSupportedImageTypes.h
    @ONLY )
endif()

=== dox/externalproject/CMakeLists.txt ===
# Example project for using elastix code from external projects.
PROJECT( elxExternalProject )

CMAKE_MINIMUM_REQUIRED( VERSION 2.8 )

# Find TIK
FIND_PACKAGE( ITK REQUIRED )
IF( ITK_FOUND )
  INCLUDE( ${ITK_USE_FILE} )
ENDIF( ITK_FOUND )

# find elastix
SET( ELASTIX_BINARY_DIR "" CACHE PATH "Path to elastix binary folder" )
SET( ELASTIX_USE_FILE ${ELASTIX_BINARY_DIR}/UseElastix.cmake )
IF( EXISTS ${ELASTIX_USE_FILE} )
 MESSAGE( STATUS "Including Elastix settings." )
 INCLUDE( ${ELASTIX_USE_FILE} )
ENDIF()

# Build a small test executable (this test is basically the same as
# the one found in the <elastix-dir>/Testing dir.
ADD_EXECUTABLE( elxtimertest itkTimerTest.cxx )

# Link to some libraries
TARGET_LINK_LIBRARIES( elxtimertest
  ITKCommon ITKBasicFilters elxCommon )

=== Components/Metrics/CorrespondingPointsEuclideanDistanceMetric/CMakeLists.txt ===

ADD_ELXCOMPONENT( CorrespondingPointsEuclideanDistanceMetric
 elxCorrespondingPointsEuclideanDistanceMetric.cxx
 elxCorrespondingPointsEuclideanDistanceMetric.h
 elxCorrespondingPointsEuclideanDistanceMetric.hxx
 itkCorrespondingPointsEuclideanDistancePointMetric.h
 itkCorrespondingPointsEuclideanDistancePointMetric.hxx )

=== Components/Metrics/DistancePreservingRigidityPenalty/CMakeLists.txt ===

ADD_ELXCOMPONENT( DistancePreservingRigidityPenalty
 elxDistancePreservingRigidityPenaltyTerm.h
 elxDistancePreservingRigidityPenaltyTerm.hxx
 elxDistancePreservingRigidityPenaltyTerm.cxx
 itkDistancePreservingRigidityPenaltyTerm.h
 itkDistancePreservingRigidityPenaltyTerm.hxx )

=== Components/Metrics/KNNGraphAlphaMutualInformation/CMakeLists.txt ===

ADD_ELXCOMPONENT( KNNGraphAlphaMutualInformationMetric
 elxKNNGraphAlphaMutualInformationMetric.h
 elxKNNGraphAlphaMutualInformationMetric.hxx
 elxKNNGraphAlphaMutualInformationMetric.cxx
 itkKNNGraphAlphaMutualInformationImageToImageMetric.h
 itkKNNGraphAlphaMutualInformationImageToImageMetric.hxx
)

if( USE_KNNGraphAlphaMutualInformationMetric )
  add_subdirectory( KNN )
  target_include_directories( KNNGraphAlphaMutualInformationMetric
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/KNN )
  target_link_libraries( KNNGraphAlphaMutualInformationMetric KNNlib ANNlib )
  elastix_export_target( KNNlib )
  elastix_export_target( ANNlib )
endif()

=== Components/Metrics/NormalizedMutualInformation/CMakeLists.txt ===

ADD_ELXCOMPONENT( NormalizedMutualInformationMetric
 elxNormalizedMutualInformationMetric.h
 elxNormalizedMutualInformationMetric.hxx
 elxNormalizedMutualInformationMetric.cxx
 itkParzenWindowNormalizedMutualInformationImageToImageMetric.h
 itkParzenWindowNormalizedMutualInformationImageToImageMetric.hxx )

=== debian/changelog ===
elastix (4.9.0-2) unstable; urgency=medium

  [ Steffen Moeller ]
  * [b3360a0] d/u/metadata: yamllint

 -- Steve M. Robbins <smr@debian.org>  Fri, 14 Aug 2020 21:36:15 -0500

elastix (4.9.0-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Fix watch file
  * debhelper 12
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Suppress dh_dwz due to: 'dwz: Too few files for multifile optimization'
  * Fix EPOCH_DATE
  * Set "Rules-Requires-Root: no" to avoid issues with fakeroot
  * Fix generation of docs using doxygen and move all code under one target
  * Install Apache NOTICE file
  * Remove unused lintian-override

  [ Jelmer Vernooĳ ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.

 -- Andreas Tille <tille@debian.org>  Tue, 15 Jan 2019 11:24:43 +0100

=== debian/control ===
Source: elastix
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>,
           Gert Wollny <gewo@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 12~),
               cmake,
               libinsighttoolkit4-dev,
               libdcmtk-dev,
               zlib1g-dev,
               libpng-dev,
               libtiff-dev,
	       libnifti-dev,
               libfftw3-dev
Build-Depends-Indep: doxygen,
                     graphviz,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-fonts-recommended,
                     texlive-publishers,
                     ghostscript
Standards-Version: 4.3.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/elastix
Vcs-Git: https://salsa.debian.org/med-team/elastix.git
Homepage: http://elastix.isi.uu.nl/

Package: elastix
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: elastix-doc
Description: toolbox for rigid and nonrigid registration of images
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.

Package: elastix-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: toolbox for rigid and nonrigid registration of images - docs
 Image registration based on the well-known Insight Segmentation and
 Registration Toolkit (ITK). The software consists of a collection of
 algorithms that are commonly used to solve (medical) image
 registration problems. The modular design of elastix allows the user
 to quickly configure, test, and compare different registration
 methods for a specific application. A command-line interface enables
 automated processing of large numbers of data sets, by means of
 scripting.
 .
 This package contains the elastix documentation.

=== debian/watch ===
version=4

https://github.com/SuperElastix/elastix/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@
